package com.liquidnet.service.dragon.receiver;

import lombok.extern.slf4j.Slf4j;
import org.springframework.data.redis.connection.Message;
import org.springframework.data.redis.connection.MessageListener;
import org.springframework.data.redis.connection.stream.MapRecord;
import org.springframework.data.redis.serializer.JdkSerializationRedisSerializer;
import org.springframework.data.redis.serializer.RedisSerializer;
import org.springframework.data.redis.serializer.StringRedisSerializer;
import org.springframework.data.redis.stream.StreamListener;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class RedisReceiver implements StreamListener<String, MapRecord<String, String, String>> {
//    @Override
//    public void onMessage(Message message, byte[] pattern) {
//        RedisSerializer serializer = new JdkSerializationRedisSerializer();
//        StringRedisSerializer stringRedisSerializer = new StringRedisSerializer();
//        //接收的topic
//        String channel = stringRedisSerializer.deserialize(message.getChannel());
//        System.out.println("INFO CHANNEL => "+channel);
//        //消息的POJO
//        Object o = serializer.deserialize(message.getBody());
//        System.out.println("INFO MESSAGE => "+o);
//    }

    @Override
    public void onMessage(MapRecord<String, String, String> message) {
        log.info("接受到来自redis的消息");
        System.out.println("message id "+message.getId());
        System.out.println("stream "+message.getStream());
        System.out.println("body "+message.getValue());
    }
}
